SystemOrganization addCategory: #DBXTalkExamples!

Object subclass: #DBXEntity
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

DBXEntity subclass: #DBXCourse
	instanceVariableNames: 'name teacher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

!DBXCourse methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:05'!
name
	^name! !

!DBXCourse methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:05'!
name: aName
	name := aName! !

!DBXCourse methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:06'!
teacher
	^teacher! !

!DBXCourse methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:06'!
teacher: aTeacher
	teacher := aTeacher! !

!DBXEntity methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 11:00'!
id
	 ^id! !

!DBXEntity methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 11:01'!
id: anId
	 id := anId! !

DBXEntity subclass: #DBXTeacher
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

!DBXTeacher methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 11:01'!
name
	^name! !

!DBXTeacher methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 11:01'!
name: aName
	name := aName! !

Object subclass: #GlorpExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

!GlorpExamples methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 16:12'!
glorpMySQLExampleLogin
	"self new glorpMySQLExampleLogin"
	| login system session courses |
	login := (Login new)
			database: MySQLPlatform new;
			databaseName: 'sodbxtest';
			username: 'sodbxtest';
			password: 'sodbxtest';
			host: 'localhost';
 		      port: '3304'.
	system := DBXTalkExampleDescriptorSystem forPlatform: login database.
	session := system sessionForLogin: login.
	session accessor login.
	
	self setUpTables: session.
	self setUpSomeData: session.
	courses := session readManyOf: DBXCourse.
	
	"force to load the instances, because the proxy will not bring anything after the logout"
	courses do: [ :course | course teacher name].
	
	courses inspect.
	session logout.! !

!GlorpExamples methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 16:12'!
glorpOracleLogin
	"self new glorpOracleLogin"
	| login system session courses |
	login := (Login new)
			database: OraclePlatform new;
			username: 'sodbxtest';
			password: 'sodbxtest';
			host: '127.0.0.1';
			port: '1521';
			connectString: '127.0.0.1_xe'.
	system := DBXTalkExampleDescriptorSystem forPlatform: login database.
	session := system sessionForLogin: login.
	session accessor login.
	
	self setUpTables: session.
	self setUpSomeData: session.
	courses := session readManyOf: DBXCourse.
	
	"force to load the instances, because the proxy will not bring anything after the logout"
	courses do: [ :course | course teacher name].
	
	courses inspect.
	session logout.! !

!GlorpExamples methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 16:12'!
glorpPostgreSQLExampleLogin
	"self new glorpPostgreSQLExampleLogin"
	| login system session courses |
	login := (Login new)
			database: PostgreSQLPlatform new;
			username: 'sodbxtest';
			password: 'sodbxtest';
			connectString: '127.0.0.1:5432_sodbxtest'.
	system := DBXTalkExampleDescriptorSystem forPlatform: login database.
	session := system sessionForLogin: login.
	session accessor login.
	
	self setUpTables: session.
	self setUpSomeData: session.
	courses := session readManyOf: DBXCourse.
	
	"force to load the instances, because the proxy will not bring anything after the logout"
	courses do: [ :course | course teacher name].
	
	courses inspect.
	session logout.! !

!GlorpExamples methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 16:12'!
glorpSQLiteExampleLogin
	"self new glorpSQLiteExampleLogin"
	| login system session courses |
	login := (Login new)
			database: SQLite3Platform new;
			host: '/home/ubuntu/sqldbs/';
			port: '';
			username: '';
			password: '';
			databaseName: 'sodbxtest.db'.
	system := DBXTalkExampleDescriptorSystem forPlatform: login database.
	session := system sessionForLogin: login.
	session accessor login.
	
	self setUpTables: session.
	self setUpSomeData: session.
	courses := session readManyOf: DBXCourse.
	
	"force to load the instances, because the proxy will not bring anything after the logout"
	courses do: [ :course | course teacher name].
	
	courses inspect.
	session logout.! !

!GlorpExamples methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 16:09'!
setUpSomeData: session
	| guille nico german computers2 programmingIntroduction graphicInterfaceDesign |
	session transact: [  

		computers2 := DBXCourse new id: 1; name: 'computers 2'; yourself.
		programmingIntroduction := DBXCourse new id: 2; name: 'Programming Introduction'; yourself.
		graphicInterfaceDesign := DBXCourse new id: 3; name: 'Graphic interface design'; yourself.

		guille := DBXTeacher new id: 1; name: 'Guille'; yourself.
		nico := DBXTeacher new id: 2; name: 'Nico'; yourself.
		german := DBXTeacher new id: 3; name: 'German'; yourself.

		session register: computers2.
		session register: programmingIntroduction.
		session register: graphicInterfaceDesign.	
	
		computers2 teacher: german.
		programmingIntroduction teacher: guille.
		graphicInterfaceDesign teacher: nico.
	].
	session reset.! !

!GlorpExamples methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:36'!
setUpTables: session
	| system errorBlock |
	errorBlock := [ :ex |  ^ex ].
	system := session system.
	session accessor dropTables: ((TableSorter for: system allTables) sort reverse).
	system platform areSequencesExplicitlyCreated ifTrue: [
		session accessor dropSequences: system allSequences.
		system allSequences do: [:each |
			session accessor createSequence: each ifError: errorBlock]].
	system allTables do: [:each | 
			session accessor createTable: each
				ifError: errorBlock].
	system allTables do: [:each |
			session accessor createTableIndexes: each ifError: errorBlock]. 
	"SQLite3 doesn't support adding/dropping constraints."
	system platform supportsConstraints ifTrue: [
		system allTables do: [:each | 
				session accessor createTableFKConstraints: each ifError: errorBlock]].! !

Object subclass: #MagritteGlorpExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

!MagritteGlorpExample methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 17:32'!
classesToBrowse
	 ^(PackageInfo named: 'DBXTalkExamples') classes select: [ :class | class name beginsWith: 'Dbxmple' ] ! !

!MagritteGlorpExample methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 21:34'!
generateBrowserExample
	"self new generateBrowserExample"
	"Carga el DS con todas las clases"
	| descriptor classesToBrowse browser |
	
	classesToBrowse := self classesToBrowse.
	
	DBXToolsBrowser browse: (classesToBrowse collect: [ :c | c new ]).! !

!MagritteGlorpExample methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 21:25'!
generateGlorpDescriptionExample
	"self new generateGlorpDescriptionExample"
	"Carga el DS con todas las clases"	
	| classesToBrowse descriptor system |
	classesToBrowse := self classesToBrowse.
	system := DBXDescriptorSystem subclass: #WitcherDS
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'DBXTalkExamples'.
		
	classesToBrowse do:[ :class | system addClass: class. ].
	
	"Levanta glorp."
	descriptor := system newConfigured.
	descriptor makeSession.
	descriptor session .! !

!MagritteGlorpExample methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/19/2011 00:43'!
generateModelFromTablesExample
	"self new generateModelFromTablesExample"
	"Postgres DBXConnection setting and open"
	| platform settings connection domainTables tableToClass excepts descriptor |
	platform := DBXPostgresBackend new.
	settings := DBXConnectionSettings 
		host: 'localhost' 
		port: '5432' 
		database: 'sodbxtest' 
		userName: 'sodbxtest' 
		userPassword: 'sodbxtest'.
	connection := DBXConnection platform: platform settings: settings.
	connection connectAndOpen.
	
	"Witcher domain table creation "
	domainTables := (WitcherDomain new ) generateMetaTables.	
	domainTables do: [ :table | connection execute: table generateCreateTable ].	
	domainTables := connection tablesDescription select:[:table | table name beginsWith: 'dbxmple_'  ].
	
	"Wticher domain class generation"
	tableToClass := DBXTableToClass new.
	domainTables do: [:aTable | tableToClass register: aTable].
	tableToClass generateAllAt: 'DBXTalkExamples-Discard'.
	
	"Database cleanup"
	domainTables do:[ :table | connection execute: table generateDropTable ].! !

Object subclass: #OpenDBXDriverExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

!OpenDBXDriverExamples methodsFor: 'queryDatabase' stamp: 'GuillermoPolito 8/25/2011 12:23'!
queryMySQLTable
	"self new queryMySQLTable"
	| settings connection resultset |
	settings := DBXConnectionSettings 
		host: 'localhost'
		port: '3306'
		database: 'sodbxtest' 
		userName: 'sodbxtest'
		userPassword: 'sodbxtest'.
	
	connection := DBXConnection 
		platform: DBXMySQLBackend new 
		settings: settings.
	[connection connectAndOpen.
	connection execute: 'CREATE TABLE USER (ID INT, NAME VARCHAR(255))'.
	connection execute: 'INSERT INTO USER VALUES(1, ''Guille'')'.
	connection execute: 'INSERT INTO USER VALUES(2, ''Santi'')'.
	connection execute: 'INSERT INTO USER VALUES(3, ''Marianito'')'.
	resultset := connection execute: 'SELECT * FROM USER'.
	resultset rows first inspect. 
	connection execute: 'DROP TABLE USER'.]
		ensure: [ connection disconnect ]! !

!OpenDBXDriverExamples methodsFor: 'queryDatabase' stamp: 'GuillermoPolito 8/25/2011 10:44'!
queryOracleTable
	"self new queryOracleTable"
	| settings connection resultset |
	settings := DBXConnectionSettings 
		host: '127.0.0.1'
		port: '1521'
		database: 'xe'
		userName: 'sodbxtest'
		userPassword: 'sodbxtest'.
	
	connection := DBXConnection 
		platform: DBXOracleBackend new 
		settings: settings.
	[connection connectAndOpen.
	connection execute: 'CREATE TABLE USERS (ID INT, NAME VARCHAR(255))'.
	connection execute: 'INSERT INTO USERS VALUES(1, ''Guille'')'.
	connection execute: 'INSERT INTO USERS VALUES(2, ''Santi'')'.
	connection execute: 'INSERT INTO USERS VALUES(3, ''Marianito'')'.
	resultset := connection execute: 'SELECT * FROM USERS'.
	DBXTranscript show: resultset. 
	connection execute: 'DROP TABLE USERS'.]
		ensure: [ connection disconnect ]! !

!OpenDBXDriverExamples methodsFor: 'queryDatabase' stamp: 'GuillermoPolito 8/25/2011 10:45'!
queryPostgreSQLTable
	"self new queryPostgreSQLTable"
	| settings connection resultset |
	settings := DBXConnectionSettings 
		host: '127.0.0.1'
		port: '5432'
		database: 'sodbxtest'
		userName: 'sodbxtest'
		userPassword: 'sodbxtest'.
	
	connection := DBXConnection 
		platform: DBXPostgresBackend new 
		settings: settings.
	[connection connectAndOpen.
	connection execute: 'CREATE TABLE USERS (ID INT, NAME VARCHAR(255))'.
	connection execute: 'INSERT INTO USERS VALUES(1, ''Guille'')'.
	connection execute: 'INSERT INTO USERS VALUES(2, ''Santi'')'.
	connection execute: 'INSERT INTO USERS VALUES(3, ''Marianito'')'.
	resultset := connection execute: 'SELECT * FROM USERS'.
	DBXTranscript show: resultset. 
	connection execute: 'DROP TABLE USERS'.]
		ensure: [ connection disconnect ]! !

!OpenDBXDriverExamples methodsFor: 'queryDatabase' stamp: 'GuillermoPolito 8/25/2011 10:33'!
querySQLiteTable
	"self new querySQLiteTable"
	| settings connection resultset |
	settings := DBXConnectionSettings 
		host: SmalltalkImage current imagePath, '/'
		port: ''
		database: 'sodbxtest.db' 
		userName: ''
		userPassword: ''.
	
	connection := DBXConnection 
		platform: DBXSqliteBackend new 
		settings: settings.
	[connection connectAndOpen.
	connection execute: 'CREATE TABLE USER (ID INT, NAME VARCHAR(255))'.
	connection execute: 'INSERT INTO USER VALUES(1, ''Guille'')'.
	connection execute: 'INSERT INTO USER VALUES(2, ''Santi'')'.
	connection execute: 'INSERT INTO USER VALUES(3, ''Marianito'')'.
	resultset := connection execute: 'SELECT * FROM USER'.
	DBXTranscript show: resultset. 
	connection execute: 'DROP TABLE USER'.]
		ensure: [ connection disconnect ]! !

GlorpTestDescriptorSystem subclass: #DBXTalkExampleDescriptorSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DBXTalkExamples'!

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 10:57'!
allTableNames
	^#( 'TEACHER' 'COURSE' ).! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:56'!
classModelForDBXCourse: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	aClassModel newAttributeNamed: #teacher type: DBXTeacher.
	! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:55'!
classModelForDBXTeacher: aClassModel
	aClassModel newAttributeNamed: #id.
	aClassModel newAttributeNamed: #name.
	! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 10:57'!
constructAllClasses
	^(super constructAllClasses)
		add: DBXTeacher;
		add: DBXCourse;
		yourself! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 13:36'!
descriptorForDBXCourse: aDescriptor
	| courseTable teacherTable |
	courseTable := self tableNamed: 'COURSE'.
	teacherTable := self tableNamed: 'TEACHER'.
	aDescriptor table: courseTable.
	(aDescriptor newMapping: DirectMapping) from: #id to: (courseTable fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name to: (courseTable fieldNamed: 'NAME').
	(aDescriptor newMapping: OneToOneMapping) 
		attributeName: #teacher;
		referenceClass: DBXTeacher;  
		join: (Join from: (courseTable fieldNamed: 'TEACHER_ID' ) to: (teacherTable fieldNamed: 'ID')).! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 12:59'!
descriptorForDBXTeacher: aDescriptor
	| table |
	table := self tableNamed: 'TEACHER'.
	aDescriptor table: table.
	(aDescriptor newMapping: DirectMapping) from: #id
				to: (table fieldNamed: 'ID').
	(aDescriptor newMapping: DirectMapping) from: #name
				to: (table fieldNamed: 'NAME').! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 14:00'!
tableForCOURSE: table
	| teacherId |
	(table createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	table createFieldNamed: 'NAME' type: (platform varchar: 40).
	teacherId := table createFieldNamed: 'TEACHER_ID' type: platform int4.
	table addForeignKeyFrom: teacherId
		to: ((self tableNamed: 'TEACHER') fieldNamed: 'ID').! !

!DBXTalkExampleDescriptorSystem methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 8/25/2011 14:00'!
tableForTEACHER: table
	| teacherId |
	(table createFieldNamed: 'ID' type: platform int4) bePrimaryKey.
	table createFieldNamed: 'NAME' type: (platform varchar: 40).! !
